import './container-query.css';
import { action } from '@ember/object';
import Component from '@glimmer/component';
import { tracked } from '@glimmer/tracking';
import { precompileTemplate } from '@ember/template-compilation';
import { g, i, n } from 'decorator-transforms/runtime';
import { setComponentTemplate } from '@ember/component';

var TEMPLATE = precompileTemplate("{{#let (element this.tagName) as |Tag|}}\n  <Tag\n    class=\"container-query\"\n    {{container-query\n      dataAttributePrefix=@dataAttributePrefix\n      debounce=@debounce\n      features=@features\n      onQuery=this.updateState\n    }}\n    ...attributes\n  >\n    {{yield\n      (hash\n        dimensions=this.dimensions features=this.queryResults\n      )\n    }}\n  </Tag>\n{{/let}}");

class ContainerQueryComponent extends Component {
  static {
    g(this.prototype, "dimensions", [tracked]);
  }
  #dimensions = (i(this, "dimensions"), void 0);
  static {
    g(this.prototype, "queryResults", [tracked]);
  }
  #queryResults = (i(this, "queryResults"), void 0);
  // The dynamic tag is restricted to be immutable
  tagName = this.args.tagName ?? 'div';
  updateState({
    dimensions,
    queryResults
  }) {
    this.dimensions = dimensions;
    this.queryResults = queryResults;
  }
  static {
    n(this.prototype, "updateState", [action]);
  }
}
setComponentTemplate(TEMPLATE, ContainerQueryComponent);

export { ContainerQueryComponent as default };
//# sourceMappingURL=container-query.js.map
